function(target_add_sanitizers target)
    if(ENABLE_CND_SANITIZER)
        if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
            set(sanitization_types address)
            set(sanitization_flag /fsanitize)
            target_compile_definitions(${target} PRIVATE _DISABLE_VECTOR_ANNOTATION _DISABLE_STRING_ANNOTATION)
            target_link_options(${target} PUBLIC /INFERASANLIBS /IGNORE:4300,4075)
        else()
            set(sanitization_types address,undefined,pointer-compare,pointer-subtract,pointer-overflow)
            set(sanitization_flag -fsanitize)
            target_link_options(${target} PRIVATE ${sanitization_flag}=${sanitization_types})
            target_link_libraries(${target} PRIVATE ubsan asan)
        endif()
        target_compile_options(${target} PRIVATE ${sanitization_flag}=${sanitization_types})
    endif()
endfunction()
